#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <pthread.h>

static int global = 0;
static  pthread_key_t key;
typedef struct data_bloc {                 // наш собственный тип данных
   pthread_t tid;
} data_t;

void put_msg( int param ) {
   printf( "global=%u , parameter=%u , own=%lu\n",
           global, param, ((data_t*)pthread_getspecific( key ))->tid );
}

static pthread_once_t once = PTHREAD_ONCE_INIT;

static void destructor( void* db ) {       // деструктор собственных данных
   data_t *p = (data_t*)db;
   free( p );
}

static void once_creator( void ) {         // создаёт единый на процесс ключ для данных data_t
   pthread_key_create( &key, destructor );
}

void* thread_proc( void *data ) {         // функция потока
   int param = (int)data;
   global++;
   pthread_once( &once,  once_creator );  // гарантия единичности создания ключа
   pthread_setspecific( key, malloc( sizeof( data_t ) ) );
   data_t *db = pthread_getspecific( key );
   db->tid = pthread_self();
   put_msg( param );
   return NULL;
}

int main( int argc, char **argv, char **envp ) {
#define TCNT 5
   pthread_t tid[ TCNT ];
   int i;
   for( i = 0; i < TCNT; i++ )
      pthread_create( &tid[ i ], NULL, thread_proc, (void*)( i + 1 ) );
   for( i = 0; i < TCNT; i++ ) 
      pthread_join( tid[ i ], NULL );
   return( EXIT_SUCCESS );
}
